/*   Author: Robert Staerk <staerk@math.stanford.edu> */
/*  Created: 7/13/95, 4:54 PM */
/* Filename: chars0.pl */
/* Abstract: The class of a character. Version with arg/3. The predicate
char_class/2 is used in tokens.pl . */

char_class(M,C) :- 
	(	M = -1 -> 
		C = end_of_file
	;	N is M + 1,
		(	1 =< N, 
			N =< 127 ->
			arg(N,
			table( /* The functor table has arity 127. */
			/*   0   */ illegal,
			/*   1   */ illegal,
			/*   2   */ illegal,
			/*   3   */ illegal,
			/*   4   */ illegal,
			/*   5   */ illegal,
			/*   6   */ illegal,
			/*   7   */ illegal,
			/*   8 BS*/ layout(space),
			/*   9 HT*/ layout(space),
			/*  10 NL*/ layout(new_line),
			/*  11 VT*/ layout(space),
			/*  12 NP*/ layout(space),
			/*  13 CR*/ layout(new_line),
			/*  14   */ illegal,
			/*  15   */ illegal,
			/*  16   */ illegal,
			/*  17   */ illegal,
			/*  18   */ illegal,
			/*  19   */ illegal,
			/*  20   */ illegal,
			/*  21   */ illegal,
			/*  22   */ illegal,
			/*  23   */ illegal,
			/*  24   */ illegal,
			/*  25   */ illegal,
			/*  26   */ end_of_file,
			/*  27   */ illegal,
			/*  28   */ illegal,
			/*  29   */ illegal,
			/*  30   */ illegal,
			/*  31 US*/ layout(new_line),
			/*  32 SP*/ layout(space),
			/*  33 ! */ solo(name(!)),
			/*  34 " */ double_quote,
			/*  35 # */ graphic(plain),
			/*  36 $ */ graphic(plain),
			/*  37 % */ end_line_comment,
			/*  38 & */ graphic(plain),
			/*  39 ' */ single_quote,
			/*  40 ( */ solo(open(layout)),
			/*  41 ) */ solo(close),
			/*  42 * */ graphic(comment_2),
			/*  43 + */ graphic(plain),
			/*  44 , */ solo(comma),
			/*  45 - */ graphic(plain),
			/*  46 . */ graphic(end),
			/*  47 / */ graphic(comment_1),
			/*  48 0 */ alpha_num(decimal_digit),
			/*  49 1 */ alpha_num(decimal_digit),
			/*  50 2 */ alpha_num(decimal_digit),
			/*  51 3 */ alpha_num(decimal_digit),
			/*  52 4 */ alpha_num(decimal_digit),
			/*  53 5 */ alpha_num(decimal_digit),
			/*  54 6 */ alpha_num(decimal_digit),
			/*  55 7 */ alpha_num(decimal_digit),
			/*  56 8 */ alpha_num(decimal_digit),
			/*  57 9 */ alpha_num(decimal_digit),
			/*  58 : */ graphic(plain),
			/*  59 ; */ solo(name(;)),
			/*  60 < */ graphic(plain),
			/*  61 = */ graphic(plain),
			/*  62 > */ graphic(plain),
			/*  63 ? */ graphic(plain),
			/*  64 @ */ graphic(plain),
			/*  65 A */ alpha_num(capital_letter),
			/*  66 B */ alpha_num(capital_letter),
			/*  67 C */ alpha_num(capital_letter),
			/*  68 D */ alpha_num(capital_letter),
			/*  69 E */ alpha_num(capital_letter),
			/*  70 F */ alpha_num(capital_letter),
			/*  71 G */ alpha_num(capital_letter),
			/*  72 H */ alpha_num(capital_letter),
			/*  73 I */ alpha_num(capital_letter),
			/*  74 J */ alpha_num(capital_letter),
			/*  75 K */ alpha_num(capital_letter),
			/*  76 L */ alpha_num(capital_letter),
			/*  77 M */ alpha_num(capital_letter),
			/*  78 N */ alpha_num(capital_letter),
			/*  79 O */ alpha_num(capital_letter),
			/*  80 P */ alpha_num(capital_letter),
			/*  81 Q */ alpha_num(capital_letter),
			/*  82 R */ alpha_num(capital_letter),
			/*  83 S */ alpha_num(capital_letter),
			/*  84 T */ alpha_num(capital_letter),
			/*  85 U */ alpha_num(capital_letter),
			/*  86 V */ alpha_num(capital_letter),
			/*  87 W */ alpha_num(capital_letter),
			/*  88 X */ alpha_num(capital_letter),
			/*  89 Y */ alpha_num(capital_letter),
			/*  90 Z */ alpha_num(capital_letter),
			/*  91 [ */ solo(open_list),
			/*  92 \ */ graphic(backslash),
			/*  93 ] */ solo(close_list),
			/*  94 ^ */ graphic(plain),
			/*  95 _ */ alpha_num(capital_letter),
			/*  96 ` */ back_quote,
			/*  97 a */ alpha_num(small_letter),
			/*  98 b */ alpha_num(small_letter),
			/*  99 c */ alpha_num(small_letter),
			/* 100 d */ alpha_num(small_letter),
			/* 101 e */ alpha_num(small_letter),
			/* 102 f */ alpha_num(small_letter),
			/* 103 g */ alpha_num(small_letter),
			/* 104 h */ alpha_num(small_letter),
			/* 105 i */ alpha_num(small_letter),
			/* 106 j */ alpha_num(small_letter),
			/* 107 k */ alpha_num(small_letter),
			/* 108 l */ alpha_num(small_letter),
			/* 109 m */ alpha_num(small_letter),
			/* 110 n */ alpha_num(small_letter),
			/* 111 o */ alpha_num(small_letter),
			/* 112 p */ alpha_num(small_letter),
			/* 113 q */ alpha_num(small_letter),
			/* 114 r */ alpha_num(small_letter),
			/* 115 s */ alpha_num(small_letter),
			/* 116 t */ alpha_num(small_letter),
			/* 117 u */ alpha_num(small_letter),
			/* 118 v */ alpha_num(small_letter),
			/* 119 w */ alpha_num(small_letter),
			/* 120 x */ alpha_num(small_letter),
			/* 121 y */ alpha_num(small_letter),
			/* 122 z */ alpha_num(small_letter),
			/* 123 { */ solo(open_curly),
			/* 124 | */ solo(head_tail_sep),
			/* 125 } */ solo(close_curly),
			/* 126 ~ */ graphic(plain)),
			C)
		;	C = illegal
		)
	).

% End of chars0.pl

